Index: /mixpp.kdevelop.filelist
===================================================================
--- /mixpp.kdevelop.filelist (revision 7)
+++ /mixpp.kdevelop.filelist (revision 8)
@@ -1,4 +1,5 @@
 # KDevelop Custom Project File List
 Makefile
+arx.cpp
 doc
 doc/latex
@@ -6,9 +7,14 @@
 itpp_ext.cpp
 itpp_ext.h
-doc
-doc/latex
-doc/latex/Makefile
 libBM.cpp
 libBM.h
 libDC.cpp
+libDC.h
+libEF.h
+libKF.cpp
+libKF.h
+libPF.cpp
+libPF.h
 test0.cpp
+testKF.cpp
+testPF.cpp
Index: /testKF.cpp
===================================================================
--- /testKF.cpp (revision 7)
+++ /testKF.cpp (revision 8)
@@ -11,36 +11,51 @@
 int main() {
 
-	mat A="1 -0.5; 1 0";
-	mat B="1;0";
-	mat C="1 0";
-	mat D="0";
-	ldmat R=ldmat("0.1");
-	ldmat Q=ldmat("0.2 0 ; 0 0.02");
-
-	ldmat P0=Q; P0*=1000.0; //increase P0
-	vec mu0="0 0";
-
-	Kalman<ldmat> KF( A,B,C,D,R,Q,P0,mu0 );
-//	cout << KF;
-
+	// Klaman filter
+	mat A, B,C,D,R,Q,P0;
+	vec mu0;
+	mat Mu0;;
+	// input from Matlab
 	it_file fin( "matlab/testKF.it" );
-	mat Dt;
+	mat Dt, Xt,Xt2;
+	int Ndat;
 
 	fin >> Name( "d" ) >> Dt;
-	int Ndat = Dt.cols();
-	mat Xt=zeros( 2,Ndat );
+	fin.seek( "A" ); 
+	fin >> A;
+	fin.seek( "B" ); 
+	fin >> B;
+	fin.seek( "C" ); 
+	fin >> C;
+	fin.seek( "D" ); 
+	fin >> D;
+	fin.seek( "R" ); 
+	fin >> R;
+	fin.seek( "Q" ); fin >> Q;
+	fin.seek( "P0" ); fin >> P0;
+	fin.seek( "mu0" ); fin >> Mu0; mu0=Mu0;
 	
+	Ndat = Dt.cols();
+	Xt=zeros( 2,Ndat );
+	Xt2=zeros( 2,Ndat );
+
+	Kalman<ldmat> KF( A,B,C,D,ldmat(R),ldmat(Q),ldmat(P0),mu0 );
+//	cout << KF;
+	KalmanFull KF2( A,B,C,D,R,Q,P0,mu0 );
 
 	Xt.set_col( 0,KF.mu );
+	Xt2.set_col( 0,KF.mu );
 	for ( int t=1;t<Ndat;t++ ) {
 		KF.bayes( Dt.get_col( t ));
+		KF2.bayes( Dt.get_col( t ));
 		Xt.set_col(t,KF.mu);
+		Xt2.set_col(t,KF2.mu);
 //		Kmu = KF.mu;
 //		cout <<  "t:" <<t<< "  " << dt<<"  "<<Kmu <<endl;
-
+		cout <<t <<endl;
 	}
 
 	it_file fou( "matlab/testKF_res.it" );
 	fou << Name("xth") << Xt;
+	fou << Name("xth2") << Xt2;
 	//Exit program:
 	return 0;
Index: /libPF.h
===================================================================
--- /libPF.h (revision 8)
+++ /libPF.h (revision 8)
@@ -0,0 +1,69 @@
+/*!
+  \file
+  \brief Bayesian Filtering using stochastic sampling (Particle Filters)
+  \author Vaclav Smidl.
+
+  -----------------------------------
+  BDM++ - C++ library for Bayesian Decision Making under Uncertainty
+
+  Using IT++ for numerical operations
+  -----------------------------------
+*/
+
+#ifndef PF_H
+#define PF_H
+
+#include <itpp/itbase.h>
+#include "libBM.h"
+#include "libDC.h"
+
+using namespace itpp;
+
+enum RESAMPLING_METHOD { MULTINOMIAL = 0, DETERMINISTIC = 1, RESIDUAL = 2, SYSTEMATIC = 3 };
+
+/*!
+* \brief A Particle Filter prototype
+
+Bayesian Filtering equations hold.
+*/
+class PF : public BM { 
+protected:
+	int n; //number of particles
+	vec w; //particle weights
+	
+public:
+	//! Returns indexes of particles that should be resampled
+	ivec resample(RESAMPLING_METHOD method = SYSTEMATIC);
+	//TODO get them on the web
+};
+
+/*!
+* \brief Trivial particle filter with proposal density that is not conditioned on the data.
+
+
+*/
+
+class TrivialPF : public PF {
+	Array<vec> ptcls;
+	
+	bool is_proposal;
+	mpdf *prop;
+	mpdf *par;
+	mpdf *obs;
+	
+	public:
+	TrivialPF(mpdf &par, mpdf &obs, mpdf &prop, int n0);
+	TrivialPF(mpdf &par, mpdf &obs, int n0);
+	void bayes(const vec &dt, bool evalll);
+};
+
+class MPF : public TrivialPF {
+	Array<BM> Bms;
+	public:
+	MPF(BM &B, mpdf &prop, mpdf &obs, mpdf &par);
+	void bayes(vec &dt);	
+};
+
+#endif // KF_H
+
+
Index: /testPF.cpp
===================================================================
--- /testPF.cpp (revision 8)
+++ /testPF.cpp (revision 8)
@@ -0,0 +1,28 @@
+#include <itpp/itbase.h>
+#include "libPF.h"
+#include "libDC.h"
+#include "libEF.h"
+
+using namespace itpp;
+
+//These lines are needed for use of cout and endl
+using std::cout;
+using std::endl;
+
+int main() {
+
+	RV x("1");
+	RV xm=x; xm.t(-1);
+	RV y("2");
+	
+	mat A = "1";
+	ldmat R("1");
+	
+	mlnorm<ldmat> obs(x,xm,A,R);
+	mlnorm<ldmat> par(y,x,A,R);
+	
+	TrivialPF TPF(obs,par,10);
+	//Exit program:
+	return 0;
+
+}
Index: /libDC.cpp
===================================================================
--- /libDC.cpp (revision 7)
+++ /libDC.cpp (revision 8)
@@ -115,9 +115,9 @@
 }
 
-void ldmat::mult_qform( const mat &C, bool trans ) {
+void ldmat::mult_sym( const mat &C, bool trans ) {
 
 //TODO better
 
-	it_assert_debug( C.cols()==L.cols(), "ldmat::mult_qform wrong input argument" );
+	it_assert_debug( C.cols()==L.cols(), "ldmat::mult_sym wrong input argument" );
 	mat Ct=C;
 
@@ -128,4 +128,26 @@
 		Ct = C.transpose();
 		Ct *= this->to_mat();
+		Ct *= C;
+	}
+
+	ldmat Lnew=ldmat( Ct );
+	L = Lnew.L;
+	D = Lnew.D;
+}
+
+void ldmat::mult_sym( const mat &C, ldmat &U, bool trans ) {
+
+//TODO better
+
+//TODO input test
+
+	mat Ct=C;
+
+	if ( trans==false ) { // return C*this*C'
+		Ct *= U.to_mat();
+		Ct *= C.transpose();
+	} else {	// return C'*this*C
+		Ct = C.transpose();
+		Ct *= U.to_mat();
 		Ct *= C;
 	}
@@ -232,5 +254,6 @@
 		kD = 1.0;
 		*kr = 0.0;
-		if ( *Df < -threshold ) it_warning( "Problem in dydr: subraction of dyad results in negative definitness. Likely mistake in calling function." );
+		if ( *Df < -threshold ) {
+		it_warning( "Problem in dydr: subraction of dyad results in negative definitness. Likely mistake in calling function." );}
 		*Df = 0.0;
 	}
Index: /matlab/itsave.m
===================================================================
--- /matlab/itsave.m (revision 7)
+++ /matlab/itsave.m (revision 8)
@@ -67,6 +67,6 @@
 
   is_scalar = all(size(v) == 1); % true if scalar (for future use)
-  is_vector = (sum(size(v) > 1) <= 1); % true if a vector (or a scalar)
-  is_intbin = min(min(v == round(v))); % true if integer or binary
+  is_vector = 0;%(sum(size(v) > 1) <= 1); % true if a vector (or a scalar)
+  is_intbin = 0;%min(min(v == round(v))); % true if integer or binary
 
   if ( isreal(v) && is_intbin ) % binary or integer type
Index: /matlab/testKF.m
===================================================================
--- /matlab/testKF.m (revision 7)
+++ /matlab/testKF.m (revision 8)
@@ -11,4 +11,6 @@
 
 N =1000;
+mu0 = [0;0];
+P0 = 200*eye(2);
 
 u = ones(1,N);
@@ -24,11 +26,14 @@
 
 d=[y;u];
-itsave('testKF.it',d)
+itsave('testKF.it',d,A,B,C,D,Q,R,P0,mu0)
+save testKF
 else
 %!cd ../testKF
 
+load testKF
 % init 
-mu = [0;0];
-P = 200*eye(2);
+mu = mu0;
+P = P0;
+EP = [0;0];
 
 for t=2:N
@@ -41,4 +46,6 @@
 	K = P*C'*iRy; 
 	P = P- K*C*P; % P = P -KCP;
+	EP(:,t) = eig(P); 
+	if any(EP<0), keyboard; end
 	mu = mu + K*(y(t)-C*mu-D*u(t));
 	Mu(1:2,t)=mu;
@@ -53,4 +60,5 @@
 hold on
 plot(xth','--');
+plot(xth2','+');
 plot(Mu',':');
 end
Index: /libDC.h
===================================================================
--- /libDC.h (revision 7)
+++ /libDC.h (revision 8)
@@ -38,10 +38,11 @@
 	virtual mat to_mat() =0;
 
-	/*! \brief Inplace multiplication by a matrix $C$ from both sides, i.e. $V = C*V*C'$
+	/*! \brief Inplace symmetric multiplication by a SQUARE matrix $C$, i.e. $V = C*V*C'$
 	@param C multiplying matrix,
 	@param trans if true, product $V = C'*V*C$ will be computed instead;
 	*/
-	virtual void mult_qform( const mat &C, bool trans=false ) =0;
+	virtual void mult_sym( const mat &C, bool trans=true ) =0;
 
+	
 	/*!
 	\brief Logarithm of a determinant.
@@ -80,5 +81,6 @@
 	void opupdt( const vec &v, double w );
 	mat to_mat();
-	void mult_qform( const mat &C, bool trans=false );
+	void mult_sym( const mat &C, bool trans=false );
+   void mult_sym( const mat &C, fsqmat &U, bool trans=false );
 	void inv(fsqmat &Inv);
 	void clear();
@@ -108,6 +110,5 @@
 	void opupdt( const vec &v, double w );
 	mat to_mat();
-	void mult_qform( const mat &C, bool trans=false );
-	void inv(sqmat* Inv);
+   void mult_sym( const mat &C, bool trans=false );
 	void add ( const ldmat &ld2, double w=1.0 );
 	double logdet();
@@ -124,6 +125,14 @@
 	*/
 	virtual void inv(ldmat &Inv);
+	
+	/*! \brief Symmetric multiplication of $U$ by a general matrix $C$, result of which is stored in the current class.
+
+	@param Inv a space where the inverse is stored.
+	
+	*/
+   void mult_sym( const mat &C, ldmat &U, bool trans=false );
 
 	ldmat& operator += (const ldmat &ldA);
+	ldmat& operator -= (const ldmat &ldA);
 	ldmat& operator *= (double x);
 	
@@ -137,4 +146,5 @@
 
 inline ldmat& ldmat::operator += (const ldmat &ldA)  {this->add(ldA);return *this;}
+inline ldmat& ldmat::operator -= (const ldmat &ldA)  {this->add(ldA,-1.0);return *this;}
 inline int ldmat::cols(){return L.cols();}
 inline int ldmat::rows(){return L.rows();}
Index: /doc/latex/classKalman.eps
===================================================================
--- /doc/latex/classKalman.eps (revision 8)
+++ /doc/latex/classKalman.eps (revision 8)
@@ -0,0 +1,197 @@
+%!PS-Adobe-2.0 EPSF-2.0
+%%Title: ClassName
+%%Creator: Doxygen
+%%CreationDate: Time
+%%For: 
+%Magnification: 1.00
+%%Orientation: Portrait
+%%BoundingBox: 0 0 500 360.36
+%%Pages: 0
+%%BeginSetup
+%%EndSetup
+%%EndComments
+
+% ----- variables -----
+
+/boxwidth 0 def
+/boxheight 40 def
+/fontheight 24 def
+/marginwidth 10 def
+/distx 20 def
+/disty 40 def
+/boundaspect 1.3875 def  % aspect ratio of the BoundingBox (width/height)
+/boundx 500 def
+/boundy boundx boundaspect div def
+/xspacing 0 def
+/yspacing 0 def
+/rows 2 def
+/cols 1 def
+/scalefactor 0 def
+/boxfont /Times-Roman findfont fontheight scalefont def
+
+% ----- procedures -----
+
+/dotted { [1 4] 0 setdash } def
+/dashed { [5] 0 setdash } def
+/solid  { [] 0 setdash } def
+
+/max % result = MAX(arg1,arg2)
+{
+  /a exch def
+  /b exch def
+  a b gt {a} {b} ifelse
+} def
+
+/xoffset % result = MAX(0,(scalefactor-(boxwidth*cols+distx*(cols-1)))/2)
+{
+  0 scalefactor boxwidth cols mul distx cols 1 sub mul add sub 2 div max
+} def
+
+/cw % boxwidth = MAX(boxwidth, stringwidth(arg1))
+{
+  /str exch def
+  /boxwidth boxwidth str stringwidth pop max def
+} def
+
+/box % draws a box with text `arg1' at grid pos (arg2,arg3)
+{ gsave
+  2 setlinewidth
+  newpath
+  exch xspacing mul xoffset add
+  exch yspacing mul
+  moveto
+  boxwidth 0 rlineto 
+  0 boxheight rlineto 
+  boxwidth neg 0 rlineto 
+  0 boxheight neg rlineto 
+  closepath
+  dup stringwidth pop neg boxwidth add 2 div
+  boxheight fontheight 2 div sub 2 div
+  rmoveto show stroke
+  grestore
+} def  
+
+/mark
+{ newpath
+  exch xspacing mul xoffset add boxwidth add
+  exch yspacing mul
+  moveto
+  0 boxheight 4 div rlineto
+  boxheight neg 4 div boxheight neg 4 div rlineto
+  closepath
+  eofill
+  stroke
+} def
+
+/arrow
+{ newpath
+  moveto
+  3 -8 rlineto
+  -6 0 rlineto
+  3 8 rlineto
+  closepath
+  eofill
+  stroke
+} def
+
+/out % draws an output connector for the block at (arg1,arg2)
+{
+  newpath
+  exch xspacing mul xoffset add boxwidth 2 div add
+  exch yspacing mul boxheight add
+  /y exch def
+  /x exch def
+  x y moveto
+  0 disty 2 div rlineto 
+  stroke
+  1 eq { x y disty 2 div add arrow } if
+} def
+
+/in % draws an input connector for the block at (arg1,arg2)
+{
+  newpath
+  exch xspacing mul xoffset add boxwidth 2 div add
+  exch yspacing mul disty 2 div sub
+  /y exch def
+  /x exch def
+  x y moveto
+  0 disty 2 div rlineto
+  stroke
+  1 eq { x y disty 2 div add arrow } if
+} def
+
+/hedge
+{
+  exch xspacing mul xoffset add boxwidth 2 div add
+  exch yspacing mul boxheight 2 div sub
+  /y exch def
+  /x exch def
+  newpath
+  x y moveto
+  boxwidth 2 div distx add 0 rlineto
+  stroke
+  1 eq
+  { newpath x boxwidth 2 div distx add add y moveto
+    -8 3 rlineto
+    0 -6 rlineto
+    8 3 rlineto
+    closepath
+    eofill
+    stroke
+  } if
+} def
+
+/vedge
+{
+  /ye exch def
+  /ys exch def
+  /xs exch def
+  newpath
+  xs xspacing mul xoffset add boxwidth 2 div add dup
+  ys yspacing mul boxheight 2 div sub
+  moveto
+  ye yspacing mul boxheight 2 div sub
+  lineto
+  stroke
+} def
+
+/conn % connections the blocks from col `arg1' to `arg2' of row `arg3'
+{
+  /ys exch def
+  /xe exch def
+  /xs exch def
+  newpath
+  xs xspacing mul xoffset add boxwidth 2 div add
+  ys yspacing mul disty 2 div sub
+  moveto
+  xspacing xe xs sub mul 0
+  rlineto
+  stroke
+} def
+
+% ----- main ------
+
+boxfont setfont
+1 boundaspect scale
+(Kalman< sq_T >) cw
+(BM) cw
+/boxwidth boxwidth marginwidth 2 mul add def
+/xspacing boxwidth distx add def
+/yspacing boxheight disty add def
+/scalefactor 
+  boxwidth cols mul distx cols 1 sub mul add
+  boxheight rows mul disty rows 1 sub mul add boundaspect mul 
+  max def
+boundx scalefactor div boundy scalefactor div scale
+
+% ----- classes -----
+
+ (Kalman< sq_T >) 0 0 box
+ (BM) 0 1 box
+
+% ----- relations -----
+
+solid
+0 0 0 out
+solid
+1 0 1 in
Index: /doc/latex/classPF.eps
===================================================================
--- /doc/latex/classPF.eps (revision 8)
+++ /doc/latex/classPF.eps (revision 8)
@@ -0,0 +1,203 @@
+%!PS-Adobe-2.0 EPSF-2.0
+%%Title: ClassName
+%%Creator: Doxygen
+%%CreationDate: Time
+%%For: 
+%Magnification: 1.00
+%%Orientation: Portrait
+%%BoundingBox: 0 0 500 845.07
+%%Pages: 0
+%%BeginSetup
+%%EndSetup
+%%EndComments
+
+% ----- variables -----
+
+/boxwidth 0 def
+/boxheight 40 def
+/fontheight 24 def
+/marginwidth 10 def
+/distx 20 def
+/disty 40 def
+/boundaspect 0.591667 def  % aspect ratio of the BoundingBox (width/height)
+/boundx 500 def
+/boundy boundx boundaspect div def
+/xspacing 0 def
+/yspacing 0 def
+/rows 3 def
+/cols 1 def
+/scalefactor 0 def
+/boxfont /Times-Roman findfont fontheight scalefont def
+
+% ----- procedures -----
+
+/dotted { [1 4] 0 setdash } def
+/dashed { [5] 0 setdash } def
+/solid  { [] 0 setdash } def
+
+/max % result = MAX(arg1,arg2)
+{
+  /a exch def
+  /b exch def
+  a b gt {a} {b} ifelse
+} def
+
+/xoffset % result = MAX(0,(scalefactor-(boxwidth*cols+distx*(cols-1)))/2)
+{
+  0 scalefactor boxwidth cols mul distx cols 1 sub mul add sub 2 div max
+} def
+
+/cw % boxwidth = MAX(boxwidth, stringwidth(arg1))
+{
+  /str exch def
+  /boxwidth boxwidth str stringwidth pop max def
+} def
+
+/box % draws a box with text `arg1' at grid pos (arg2,arg3)
+{ gsave
+  2 setlinewidth
+  newpath
+  exch xspacing mul xoffset add
+  exch yspacing mul
+  moveto
+  boxwidth 0 rlineto 
+  0 boxheight rlineto 
+  boxwidth neg 0 rlineto 
+  0 boxheight neg rlineto 
+  closepath
+  dup stringwidth pop neg boxwidth add 2 div
+  boxheight fontheight 2 div sub 2 div
+  rmoveto show stroke
+  grestore
+} def  
+
+/mark
+{ newpath
+  exch xspacing mul xoffset add boxwidth add
+  exch yspacing mul
+  moveto
+  0 boxheight 4 div rlineto
+  boxheight neg 4 div boxheight neg 4 div rlineto
+  closepath
+  eofill
+  stroke
+} def
+
+/arrow
+{ newpath
+  moveto
+  3 -8 rlineto
+  -6 0 rlineto
+  3 8 rlineto
+  closepath
+  eofill
+  stroke
+} def
+
+/out % draws an output connector for the block at (arg1,arg2)
+{
+  newpath
+  exch xspacing mul xoffset add boxwidth 2 div add
+  exch yspacing mul boxheight add
+  /y exch def
+  /x exch def
+  x y moveto
+  0 disty 2 div rlineto 
+  stroke
+  1 eq { x y disty 2 div add arrow } if
+} def
+
+/in % draws an input connector for the block at (arg1,arg2)
+{
+  newpath
+  exch xspacing mul xoffset add boxwidth 2 div add
+  exch yspacing mul disty 2 div sub
+  /y exch def
+  /x exch def
+  x y moveto
+  0 disty 2 div rlineto
+  stroke
+  1 eq { x y disty 2 div add arrow } if
+} def
+
+/hedge
+{
+  exch xspacing mul xoffset add boxwidth 2 div add
+  exch yspacing mul boxheight 2 div sub
+  /y exch def
+  /x exch def
+  newpath
+  x y moveto
+  boxwidth 2 div distx add 0 rlineto
+  stroke
+  1 eq
+  { newpath x boxwidth 2 div distx add add y moveto
+    -8 3 rlineto
+    0 -6 rlineto
+    8 3 rlineto
+    closepath
+    eofill
+    stroke
+  } if
+} def
+
+/vedge
+{
+  /ye exch def
+  /ys exch def
+  /xs exch def
+  newpath
+  xs xspacing mul xoffset add boxwidth 2 div add dup
+  ys yspacing mul boxheight 2 div sub
+  moveto
+  ye yspacing mul boxheight 2 div sub
+  lineto
+  stroke
+} def
+
+/conn % connections the blocks from col `arg1' to `arg2' of row `arg3'
+{
+  /ys exch def
+  /xe exch def
+  /xs exch def
+  newpath
+  xs xspacing mul xoffset add boxwidth 2 div add
+  ys yspacing mul disty 2 div sub
+  moveto
+  xspacing xe xs sub mul 0
+  rlineto
+  stroke
+} def
+
+% ----- main ------
+
+boxfont setfont
+1 boundaspect scale
+(PF) cw
+(BM) cw
+(TrivialPF) cw
+/boxwidth boxwidth marginwidth 2 mul add def
+/xspacing boxwidth distx add def
+/yspacing boxheight disty add def
+/scalefactor 
+  boxwidth cols mul distx cols 1 sub mul add
+  boxheight rows mul disty rows 1 sub mul add boundaspect mul 
+  max def
+boundx scalefactor div boundy scalefactor div scale
+
+% ----- classes -----
+
+ (PF) 0 1 box
+ (BM) 0 2 box
+ (TrivialPF) 0 0 box
+
+% ----- relations -----
+
+solid
+0 0 1 out
+solid
+1 0 2 in
+solid
+1 0 0.25 out
+solid
+0 0 0.75 in
Index: /doc/latex/classenorm.eps
===================================================================
--- /doc/latex/classenorm.eps (revision 8)
+++ /doc/latex/classenorm.eps (revision 8)
@@ -0,0 +1,203 @@
+%!PS-Adobe-2.0 EPSF-2.0
+%%Title: ClassName
+%%Creator: Doxygen
+%%CreationDate: Time
+%%For: 
+%Magnification: 1.00
+%%Orientation: Portrait
+%%BoundingBox: 0 0 500 571.429
+%%Pages: 0
+%%BeginSetup
+%%EndSetup
+%%EndComments
+
+% ----- variables -----
+
+/boxwidth 0 def
+/boxheight 40 def
+/fontheight 24 def
+/marginwidth 10 def
+/distx 20 def
+/disty 40 def
+/boundaspect 0.875 def  % aspect ratio of the BoundingBox (width/height)
+/boundx 500 def
+/boundy boundx boundaspect div def
+/xspacing 0 def
+/yspacing 0 def
+/rows 3 def
+/cols 1 def
+/scalefactor 0 def
+/boxfont /Times-Roman findfont fontheight scalefont def
+
+% ----- procedures -----
+
+/dotted { [1 4] 0 setdash } def
+/dashed { [5] 0 setdash } def
+/solid  { [] 0 setdash } def
+
+/max % result = MAX(arg1,arg2)
+{
+  /a exch def
+  /b exch def
+  a b gt {a} {b} ifelse
+} def
+
+/xoffset % result = MAX(0,(scalefactor-(boxwidth*cols+distx*(cols-1)))/2)
+{
+  0 scalefactor boxwidth cols mul distx cols 1 sub mul add sub 2 div max
+} def
+
+/cw % boxwidth = MAX(boxwidth, stringwidth(arg1))
+{
+  /str exch def
+  /boxwidth boxwidth str stringwidth pop max def
+} def
+
+/box % draws a box with text `arg1' at grid pos (arg2,arg3)
+{ gsave
+  2 setlinewidth
+  newpath
+  exch xspacing mul xoffset add
+  exch yspacing mul
+  moveto
+  boxwidth 0 rlineto 
+  0 boxheight rlineto 
+  boxwidth neg 0 rlineto 
+  0 boxheight neg rlineto 
+  closepath
+  dup stringwidth pop neg boxwidth add 2 div
+  boxheight fontheight 2 div sub 2 div
+  rmoveto show stroke
+  grestore
+} def  
+
+/mark
+{ newpath
+  exch xspacing mul xoffset add boxwidth add
+  exch yspacing mul
+  moveto
+  0 boxheight 4 div rlineto
+  boxheight neg 4 div boxheight neg 4 div rlineto
+  closepath
+  eofill
+  stroke
+} def
+
+/arrow
+{ newpath
+  moveto
+  3 -8 rlineto
+  -6 0 rlineto
+  3 8 rlineto
+  closepath
+  eofill
+  stroke
+} def
+
+/out % draws an output connector for the block at (arg1,arg2)
+{
+  newpath
+  exch xspacing mul xoffset add boxwidth 2 div add
+  exch yspacing mul boxheight add
+  /y exch def
+  /x exch def
+  x y moveto
+  0 disty 2 div rlineto 
+  stroke
+  1 eq { x y disty 2 div add arrow } if
+} def
+
+/in % draws an input connector for the block at (arg1,arg2)
+{
+  newpath
+  exch xspacing mul xoffset add boxwidth 2 div add
+  exch yspacing mul disty 2 div sub
+  /y exch def
+  /x exch def
+  x y moveto
+  0 disty 2 div rlineto
+  stroke
+  1 eq { x y disty 2 div add arrow } if
+} def
+
+/hedge
+{
+  exch xspacing mul xoffset add boxwidth 2 div add
+  exch yspacing mul boxheight 2 div sub
+  /y exch def
+  /x exch def
+  newpath
+  x y moveto
+  boxwidth 2 div distx add 0 rlineto
+  stroke
+  1 eq
+  { newpath x boxwidth 2 div distx add add y moveto
+    -8 3 rlineto
+    0 -6 rlineto
+    8 3 rlineto
+    closepath
+    eofill
+    stroke
+  } if
+} def
+
+/vedge
+{
+  /ye exch def
+  /ys exch def
+  /xs exch def
+  newpath
+  xs xspacing mul xoffset add boxwidth 2 div add dup
+  ys yspacing mul boxheight 2 div sub
+  moveto
+  ye yspacing mul boxheight 2 div sub
+  lineto
+  stroke
+} def
+
+/conn % connections the blocks from col `arg1' to `arg2' of row `arg3'
+{
+  /ys exch def
+  /xe exch def
+  /xs exch def
+  newpath
+  xs xspacing mul xoffset add boxwidth 2 div add
+  ys yspacing mul disty 2 div sub
+  moveto
+  xspacing xe xs sub mul 0
+  rlineto
+  stroke
+} def
+
+% ----- main ------
+
+boxfont setfont
+1 boundaspect scale
+(enorm< sq_T >) cw
+(eEF) cw
+(epdf) cw
+/boxwidth boxwidth marginwidth 2 mul add def
+/xspacing boxwidth distx add def
+/yspacing boxheight disty add def
+/scalefactor 
+  boxwidth cols mul distx cols 1 sub mul add
+  boxheight rows mul disty rows 1 sub mul add boundaspect mul 
+  max def
+boundx scalefactor div boundy scalefactor div scale
+
+% ----- classes -----
+
+ (enorm< sq_T >) 0 0 box
+ (eEF) 0 1 box
+ (epdf) 0 2 box
+
+% ----- relations -----
+
+solid
+0 0 0 out
+solid
+1 0 1 in
+solid
+0 0 1 out
+solid
+1 0 2 in
Index: /doc/latex/classsqmat.eps
===================================================================
--- /doc/latex/classsqmat.eps (revision 8)
+++ /doc/latex/classsqmat.eps (revision 8)
@@ -0,0 +1,197 @@
+%!PS-Adobe-2.0 EPSF-2.0
+%%Title: ClassName
+%%Creator: Doxygen
+%%CreationDate: Time
+%%For: 
+%Magnification: 1.00
+%%Orientation: Portrait
+%%BoundingBox: 0 0 500 727.273
+%%Pages: 0
+%%BeginSetup
+%%EndSetup
+%%EndComments
+
+% ----- variables -----
+
+/boxwidth 0 def
+/boxheight 40 def
+/fontheight 24 def
+/marginwidth 10 def
+/distx 20 def
+/disty 40 def
+/boundaspect 0.6875 def  % aspect ratio of the BoundingBox (width/height)
+/boundx 500 def
+/boundy boundx boundaspect div def
+/xspacing 0 def
+/yspacing 0 def
+/rows 2 def
+/cols 1 def
+/scalefactor 0 def
+/boxfont /Times-Roman findfont fontheight scalefont def
+
+% ----- procedures -----
+
+/dotted { [1 4] 0 setdash } def
+/dashed { [5] 0 setdash } def
+/solid  { [] 0 setdash } def
+
+/max % result = MAX(arg1,arg2)
+{
+  /a exch def
+  /b exch def
+  a b gt {a} {b} ifelse
+} def
+
+/xoffset % result = MAX(0,(scalefactor-(boxwidth*cols+distx*(cols-1)))/2)
+{
+  0 scalefactor boxwidth cols mul distx cols 1 sub mul add sub 2 div max
+} def
+
+/cw % boxwidth = MAX(boxwidth, stringwidth(arg1))
+{
+  /str exch def
+  /boxwidth boxwidth str stringwidth pop max def
+} def
+
+/box % draws a box with text `arg1' at grid pos (arg2,arg3)
+{ gsave
+  2 setlinewidth
+  newpath
+  exch xspacing mul xoffset add
+  exch yspacing mul
+  moveto
+  boxwidth 0 rlineto 
+  0 boxheight rlineto 
+  boxwidth neg 0 rlineto 
+  0 boxheight neg rlineto 
+  closepath
+  dup stringwidth pop neg boxwidth add 2 div
+  boxheight fontheight 2 div sub 2 div
+  rmoveto show stroke
+  grestore
+} def  
+
+/mark
+{ newpath
+  exch xspacing mul xoffset add boxwidth add
+  exch yspacing mul
+  moveto
+  0 boxheight 4 div rlineto
+  boxheight neg 4 div boxheight neg 4 div rlineto
+  closepath
+  eofill
+  stroke
+} def
+
+/arrow
+{ newpath
+  moveto
+  3 -8 rlineto
+  -6 0 rlineto
+  3 8 rlineto
+  closepath
+  eofill
+  stroke
+} def
+
+/out % draws an output connector for the block at (arg1,arg2)
+{
+  newpath
+  exch xspacing mul xoffset add boxwidth 2 div add
+  exch yspacing mul boxheight add
+  /y exch def
+  /x exch def
+  x y moveto
+  0 disty 2 div rlineto 
+  stroke
+  1 eq { x y disty 2 div add arrow } if
+} def
+
+/in % draws an input connector for the block at (arg1,arg2)
+{
+  newpath
+  exch xspacing mul xoffset add boxwidth 2 div add
+  exch yspacing mul disty 2 div sub
+  /y exch def
+  /x exch def
+  x y moveto
+  0 disty 2 div rlineto
+  stroke
+  1 eq { x y disty 2 div add arrow } if
+} def
+
+/hedge
+{
+  exch xspacing mul xoffset add boxwidth 2 div add
+  exch yspacing mul boxheight 2 div sub
+  /y exch def
+  /x exch def
+  newpath
+  x y moveto
+  boxwidth 2 div distx add 0 rlineto
+  stroke
+  1 eq
+  { newpath x boxwidth 2 div distx add add y moveto
+    -8 3 rlineto
+    0 -6 rlineto
+    8 3 rlineto
+    closepath
+    eofill
+    stroke
+  } if
+} def
+
+/vedge
+{
+  /ye exch def
+  /ys exch def
+  /xs exch def
+  newpath
+  xs xspacing mul xoffset add boxwidth 2 div add dup
+  ys yspacing mul boxheight 2 div sub
+  moveto
+  ye yspacing mul boxheight 2 div sub
+  lineto
+  stroke
+} def
+
+/conn % connections the blocks from col `arg1' to `arg2' of row `arg3'
+{
+  /ys exch def
+  /xe exch def
+  /xs exch def
+  newpath
+  xs xspacing mul xoffset add boxwidth 2 div add
+  ys yspacing mul disty 2 div sub
+  moveto
+  xspacing xe xs sub mul 0
+  rlineto
+  stroke
+} def
+
+% ----- main ------
+
+boxfont setfont
+1 boundaspect scale
+(sqmat) cw
+(fsqmat) cw
+/boxwidth boxwidth marginwidth 2 mul add def
+/xspacing boxwidth distx add def
+/yspacing boxheight disty add def
+/scalefactor 
+  boxwidth cols mul distx cols 1 sub mul add
+  boxheight rows mul disty rows 1 sub mul add boundaspect mul 
+  max def
+boundx scalefactor div boundy scalefactor div scale
+
+% ----- classes -----
+
+ (sqmat) 0 1 box
+ (fsqmat) 0 0 box
+
+% ----- relations -----
+
+dotted
+1 0 0.25 out
+dotted
+0 0 0.75 in
Index: /doc/latex/classKalmanFull.eps
===================================================================
--- /doc/latex/classKalmanFull.eps (revision 8)
+++ /doc/latex/classKalmanFull.eps (revision 8)
@@ -0,0 +1,197 @@
+%!PS-Adobe-2.0 EPSF-2.0
+%%Title: ClassName
+%%Creator: Doxygen
+%%CreationDate: Time
+%%For: 
+%Magnification: 1.00
+%%Orientation: Portrait
+%%BoundingBox: 0 0 500 487.805
+%%Pages: 0
+%%BeginSetup
+%%EndSetup
+%%EndComments
+
+% ----- variables -----
+
+/boxwidth 0 def
+/boxheight 40 def
+/fontheight 24 def
+/marginwidth 10 def
+/distx 20 def
+/disty 40 def
+/boundaspect 1.025 def  % aspect ratio of the BoundingBox (width/height)
+/boundx 500 def
+/boundy boundx boundaspect div def
+/xspacing 0 def
+/yspacing 0 def
+/rows 2 def
+/cols 1 def
+/scalefactor 0 def
+/boxfont /Times-Roman findfont fontheight scalefont def
+
+% ----- procedures -----
+
+/dotted { [1 4] 0 setdash } def
+/dashed { [5] 0 setdash } def
+/solid  { [] 0 setdash } def
+
+/max % result = MAX(arg1,arg2)
+{
+  /a exch def
+  /b exch def
+  a b gt {a} {b} ifelse
+} def
+
+/xoffset % result = MAX(0,(scalefactor-(boxwidth*cols+distx*(cols-1)))/2)
+{
+  0 scalefactor boxwidth cols mul distx cols 1 sub mul add sub 2 div max
+} def
+
+/cw % boxwidth = MAX(boxwidth, stringwidth(arg1))
+{
+  /str exch def
+  /boxwidth boxwidth str stringwidth pop max def
+} def
+
+/box % draws a box with text `arg1' at grid pos (arg2,arg3)
+{ gsave
+  2 setlinewidth
+  newpath
+  exch xspacing mul xoffset add
+  exch yspacing mul
+  moveto
+  boxwidth 0 rlineto 
+  0 boxheight rlineto 
+  boxwidth neg 0 rlineto 
+  0 boxheight neg rlineto 
+  closepath
+  dup stringwidth pop neg boxwidth add 2 div
+  boxheight fontheight 2 div sub 2 div
+  rmoveto show stroke
+  grestore
+} def  
+
+/mark
+{ newpath
+  exch xspacing mul xoffset add boxwidth add
+  exch yspacing mul
+  moveto
+  0 boxheight 4 div rlineto
+  boxheight neg 4 div boxheight neg 4 div rlineto
+  closepath
+  eofill
+  stroke
+} def
+
+/arrow
+{ newpath
+  moveto
+  3 -8 rlineto
+  -6 0 rlineto
+  3 8 rlineto
+  closepath
+  eofill
+  stroke
+} def
+
+/out % draws an output connector for the block at (arg1,arg2)
+{
+  newpath
+  exch xspacing mul xoffset add boxwidth 2 div add
+  exch yspacing mul boxheight add
+  /y exch def
+  /x exch def
+  x y moveto
+  0 disty 2 div rlineto 
+  stroke
+  1 eq { x y disty 2 div add arrow } if
+} def
+
+/in % draws an input connector for the block at (arg1,arg2)
+{
+  newpath
+  exch xspacing mul xoffset add boxwidth 2 div add
+  exch yspacing mul disty 2 div sub
+  /y exch def
+  /x exch def
+  x y moveto
+  0 disty 2 div rlineto
+  stroke
+  1 eq { x y disty 2 div add arrow } if
+} def
+
+/hedge
+{
+  exch xspacing mul xoffset add boxwidth 2 div add
+  exch yspacing mul boxheight 2 div sub
+  /y exch def
+  /x exch def
+  newpath
+  x y moveto
+  boxwidth 2 div distx add 0 rlineto
+  stroke
+  1 eq
+  { newpath x boxwidth 2 div distx add add y moveto
+    -8 3 rlineto
+    0 -6 rlineto
+    8 3 rlineto
+    closepath
+    eofill
+    stroke
+  } if
+} def
+
+/vedge
+{
+  /ye exch def
+  /ys exch def
+  /xs exch def
+  newpath
+  xs xspacing mul xoffset add boxwidth 2 div add dup
+  ys yspacing mul boxheight 2 div sub
+  moveto
+  ye yspacing mul boxheight 2 div sub
+  lineto
+  stroke
+} def
+
+/conn % connections the blocks from col `arg1' to `arg2' of row `arg3'
+{
+  /ys exch def
+  /xe exch def
+  /xs exch def
+  newpath
+  xs xspacing mul xoffset add boxwidth 2 div add
+  ys yspacing mul disty 2 div sub
+  moveto
+  xspacing xe xs sub mul 0
+  rlineto
+  stroke
+} def
+
+% ----- main ------
+
+boxfont setfont
+1 boundaspect scale
+(KalmanFull) cw
+(BM) cw
+/boxwidth boxwidth marginwidth 2 mul add def
+/xspacing boxwidth distx add def
+/yspacing boxheight disty add def
+/scalefactor 
+  boxwidth cols mul distx cols 1 sub mul add
+  boxheight rows mul disty rows 1 sub mul add boundaspect mul 
+  max def
+boundx scalefactor div boundy scalefactor div scale
+
+% ----- classes -----
+
+ (KalmanFull) 0 0 box
+ (BM) 0 1 box
+
+% ----- relations -----
+
+solid
+0 0 0 out
+solid
+1 0 1 in
